#!/bin/bash

# Class named 'NWCModule' for UPDATE.sh bash object emulation

# property
properties=()

# properties IDs (only placeholder with incrementing array position value)
name=0
disableFileLock=1
dbIniFile=2
anOtherProperty=3

# predefined properties
properties[name]='NWCModule'
# set 1 to disable file lock, this disables the uninstall() method and will run install() on every openitcockpit-update if the module folder exists
properties[disableFileLock]=1

# do not change this method!
NWCModule.property() {
  if [ "$2" == "=" ]; then
    properties[$1]=$3
  else
    echo ${properties[$1]}
  fi
}

# runs on every openitcockpit-update
NWCModule.initialize() {
  NWCModule.installIfNeeded
}

NWCModule.installIfNeeded() {
  if [ $(NWCModule.property disableFileLock) == 1 ]; then
    if [ $(system.moduleSrcDirExists $(NWCModule.property name)) == 1 ]; then
      NWCModule.install
    fi
  else
    if [ $(system.moduleSrcDirExists $(NWCModule.property name)) == 1 ]; then
      if [ "$(system.isLocked $(NWCModule.property name) 'installed')" != 1 ]; then
        NWCModule.install
      fi
    else
      if [ "$(system.isLocked $(NWCModule.property name) 'installed')" == 1 ]; then
        NWCModule.uninstall
      fi
    fi
  fi
}

NWCModule.install() {
  # insert custom code
  system.lock $(NWCModule.property name) "installed" $(NWCModule.property disableFileLock)
}

NWCModule.uninstall() {
  echo "I am the migrated postrm routine of $(NWCModule.property name)"
  # insert custom code
  system.unlock $(NWCModule.property name) "installed" $(NWCModule.property disableFileLock)
}

NWCModule.finish() {
  if [ $(system.moduleSrcDirExists $(NWCModule.property name)) == 1 ]; then
    # insert custom code
    echo "I run after every openitcockpit-update" >/dev/null
  fi
}
